/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
import { IRegistrable } from "./registrable";
export declare function Component(parameters: IComponent): <T>(constructor: {
    new (...args: any[]): T;
}) => void;
export declare function InputBinding(target: Object, propertyKey: string | symbol): void;
export declare function OutputBinding(target: Object, propertyKey: string | symbol): void;
export declare function TextBinding(target: Object, propertyKey: string | symbol): void;
export declare function TwoWayBinding(target: Object, propertyKey: string | symbol): void;
export declare function Require(controller: string | Function, searchOnParents?: boolean): Function;
export interface IComponent extends IRegistrable {
    component?: Function;
    componentAs?: string;
    templateUrl?: string;
    template?: string;
    bindings?: {
        [boundProperty: string]: string;
    };
    transclude?: boolean | {
        [slot: string]: string;
    };
    require?: {
        [controller: string]: string;
    };
    resolve?: Object;
}
