"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var angular_service_1 = require("../services/angular.service");
var directive_1 = require("../decorators/directive");
var base_directive_1 = require("./base.directive");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var MdUiSrefActiveDirective = /** @class */ (function (_super) {
    tslib_1.__extends(MdUiSrefActiveDirective, _super);
    function MdUiSrefActiveDirective(interpolate, state, transitions) {
        var _this = _super.call(this) || this;
        _this.interpolate = interpolate;
        _this.state = state;
        _this.transitions = transitions;
        return _this;
    }
    MdUiSrefActiveDirective_1 = MdUiSrefActiveDirective;
    MdUiSrefActiveDirective.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var _this = this;
        var cssClass = instanceAttributes["mdUiSrefActive"];
        var state = this.interpolate(instanceAttributes["mdUiSref"] || instanceAttributes["uiSref"])(scope);
        function update(toState) {
            if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(toState) || paradigm_ui_web_shared_1.ObjectExtensions.isNull(toState.name))
                return;
            if (toState.name.indexOf(state) !== -1) {
                instanceElement.addClass(cssClass);
            }
            else {
                instanceElement.removeClass(cssClass);
            }
        }
        update(this.state.current);
        instanceElement["transition-event"] = this.transitions.onSuccess({}, function () {
            update(_this.state.current);
        });
    };
    MdUiSrefActiveDirective.prototype.dispose = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var hookOff = instanceElement["transition-event"];
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(hookOff)) {
            instanceElement["transition-event"]();
            instanceElement["transition-event"] = null;
        }
        _super.prototype.dispose.call(this, scope, instanceElement, instanceAttributes, controller, transclude);
    };
    MdUiSrefActiveDirective.factory = function (interpolate, state, transitions) {
        return new MdUiSrefActiveDirective_1(interpolate, state, transitions);
    };
    MdUiSrefActiveDirective = MdUiSrefActiveDirective_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "mdUiSrefActive",
            restrict: "A",
            dependencies: [angular_service_1.AngularServices.interpolate, angular_service_1.AngularServices.state, angular_service_1.AngularServices.transitions]
        })
    ], MdUiSrefActiveDirective);
    return MdUiSrefActiveDirective;
    var MdUiSrefActiveDirective_1;
}(base_directive_1.DirectiveBase));
exports.MdUiSrefActiveDirective = MdUiSrefActiveDirective;
